﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Collections;

namespace Time_Pilot.FlyingObjects
{
    class Biplane : FlyingObject
    {
        TimePilot tp;
        TimePilotScreen screen;
        EnnemyBullet bullet = null;
        ManualBomb bomb = null;
        int timeCounter = 0;

        Rectangle[] spritesCoord = new Rectangle[12];



        public Biplane(int d, Point p, TimePilotScreen s)
            : base(1, d, p)
        {
            tp = s.timepilot;
            screen = s;

            for (int i = 0; i < 12; i++)
            {
                spritesCoord[i] = new Rectangle(i * 38, 38, 38, 38);
            }    
        }



        public override void step()
        {
            Random rand = new Random();
            if (timeCounter == 17)
            {
                if (rand.NextDouble() > 0.5) turnClockWise();
                else turnCounterClockWise();
                timeCounter = 0;
            }
            else timeCounter++;
            if (position.X < -100) position.X = 547;
            else if (position.X > 547) position.X = -100;
            if (position.Y < -100) position.Y = 448;
            else if (position.Y > 448) position.Y = -100;
            else
            {

                base.step();

                position.X += (int)(Math.Cos(rad(tp.oppositeDirection())) * (3 + speed));
                position.Y += (int)(Math.Sin(rad(tp.oppositeDirection())) * (3 + speed));
                int res = 10;
                if ((res = this.isHitBy(tp.bullets)) <= 1)
                    screen.planeIsHit(this, res);
            }
        }



        public override void fire()
        {

            if ((bullet == null) || ((bullet.posX() < 0 || bullet.posX() > 527)
            || (bullet.posY() < 0 || bullet.posY() > 428)))
            {
                bullet = new EnnemyBullet(this, tp, 4);
                screen.bullets.Add(bullet);               
            }
        }



        public override void dropBomb()
        {

            if ((bomb == null) || ((bomb.posX() < 0 || bomb.posX() > 527)
            && (bomb.posY() < 0 || bomb.posY() > 428)))
            {
                bomb = new ManualBomb(new Point(position.X, position.Y), tp, screen);                
                screen.bullets.Add(bomb);
                SoundPlayer.Play("BOMB");
            }
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
            theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[((direction / 30) + 3) % 12], Color.White);
        }


    }
}
