﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
namespace Time_Pilot.FlyingObjects
{
    class EnnemyBullet : FlyingObject
    {
        TimePilot timePilot;

        public EnnemyBullet(FlyingObject b, TimePilot tp, int speed)
            : base(speed, b.getDirection(),
              new Point((int)(b.posX() - 19 + 10 * Math.Cos(b.getDirection() * Math.PI / 180)),
                (int)(b.posY() - 19 + 10 * Math.Sin(b.getDirection() * Math.PI / 180))))
        {
            timePilot = tp;
        }

        public EnnemyBullet(FlyingObject b, TimePilot tp, int xRel, int yRel, int speed)
           : base(speed, b.getDirection(),
              new Point((int)(b.posX() - 19 + xRel + 10 * Math.Cos(b.getDirection() * Math.PI / 180)),
              (int)(b.posY() - 19 + yRel + 10 * Math.Sin(b.getDirection() * Math.PI / 180))))
            {
            timePilot = tp;
        }

        public EnnemyBullet(FlyingObject b, int dir, TimePilot tp, int xRel, int yRel, int speed)        
           : base(speed, b.getDirection(),
              new Point((int)(b.posX() - 19 + xRel + 10 * Math.Cos(b.getDirection() * Math.PI / 180)),
              (int)(b.posY() - 19 + yRel + 10 * Math.Sin(b.getDirection() * Math.PI / 180))))
            {
            timePilot = tp;
        }


        public override void step()
        {
            base.step();

            position.X += (int)(Math.Cos(rad(timePilot.oppositeDirection())) * 4);
            position.Y += (int)(Math.Sin(rad(timePilot.oppositeDirection())) * 4);


            if ((Math.Abs(position.X - 244) < 12) && (Math.Abs(position.Y - 195) < 12))
            {
                timePilot.isHit();
                endCourse = true;
            }
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {                        
                theSpriteBatch.Draw(texture, new Rectangle(position.X, position.Y, 4, 4), new Rectangle(140, 250, 4, 4), Color.Yellow);          
        }

    }
}
