﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;

namespace Time_Pilot.FlyingObjects
{
    class FinalPlane : FlyingObject
    {
        int nbHits = 0;
        public EnnemyBullet bullet = null;
        public TimePilotScreen screen;
        public Boolean notDone = true;

        public FinalPlane(int d, Point p, TimePilotScreen s)
            : base(1, d, p)
        {
            screen = s;
            notDone = true;
        }



        public override void fire()
        {

            if ((bullet == null) || ((bullet.posX() < 0 || bullet.posX() > 527)
            || (bullet.posY() < 0 || bullet.posY() > 428)))
            {
                int dir = (int)((new Random().NextDouble() * 1000) % 360);
                bullet = new EnnemyBullet(this, dir, screen.timepilot, 30, 25, 4);
                screen.bullets.Add(bullet);                
            }
        }



        public override void step()
        {
            if (posX() < -100) position.X = 580;
            else if (posX() > 580) position.X = -100;
            if (posY() < -100) position.Y = 448;
            else if (posY() > 448) position.Y = -100;
            else
            {

                base.step();

                position.X += (int)(Math.Cos(rad(screen.timepilot.oppositeDirection())) * (3 + speed));
                position.Y += (int)(Math.Sin(rad(screen.timepilot.oppositeDirection())) * (3 + speed));
            }
            int res = 10;
            if ((res = this.isHitBy(screen.timepilot.bullets)) <= 1)
                screen.finalPlaneIsHit(this, res, nbHits);

            for (int i = 0; i < nbHits / 6; i++)
                screen.finalPlaneIsHit(this, 0, nbHits);
        }

        public override int isHitBy(ArrayList bullets)
        {
            ArrayList bulletsToRemove = new ArrayList();
            foreach (FlyingObject bullet in bullets)  {         
                if ((Math.Abs((position.X) - bullet.posX()) < 25) &&
                    (Math.Abs((position.Y) - bullet.posY()) < 19))
                {
                    bulletsToRemove.Add(bullet);
                    nbHits++;
                    return 0;
                }
            }
            foreach (FlyingObject bullet in bulletsToRemove) {
                bullets.Remove(bullet);
            }
            if ((Math.Abs((position.X) - 244) < 50) && (Math.Abs((position.Y) - 195) < 22))
            {
                return 1;
            }
            else return 2;
        }

        public override Boolean bulletWillHit()
        {
            return true;
        }

    }
}
