﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;

namespace Time_Pilot.FlyingObjects
{
    class ManualBomb : FlyingObject
    {
        Boolean ccw = false;
        TimePilot timePilot;
        TimePilotScreen screen;

        Rectangle[] spritesCoord = { new Rectangle(228, 5 * 38, 38, 38), new Rectangle(266, 5 * 38, 38, 38) };

        public ManualBomb(Point p, TimePilot t, TimePilotScreen s)
            : base(4, 210, p)
        {
            timePilot = t;
            screen = s;
            Random rand = new Random();
            if (rand.NextDouble() > 0.5)
            {
                ccw = true;
                direction = 330;
            }

        }



        public override void step()
        {
            if (direction != 90)
            {
                if (ccw) turnCounterClockWise(3);
                else turnClockWise(3);
            }
            base.step();

            position.X += (int)(Math.Cos(rad(timePilot.oppositeDirection())) * speed);
            position.Y += (int)(Math.Sin(rad(timePilot.oppositeDirection())) * speed);
            int res = 10;
            if ((res = this.isHitBy(timePilot.bullets)) <= 1) 
                screen.projectileIsHit(this, res);            
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
            if (ccw)
                theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[1], Color.White);
            else
                theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[0], Color.White);
        }

    }
}
