﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;


namespace Time_Pilot.FlyingObjects
{
    class Missile : FlyingObject
    {

        TimePilot tp;
        TimePilotScreen screen;
        Boolean ccw = false;

        Rectangle[] spritesCoord = new Rectangle[12];

        public Missile(Point p, int dir, TimePilotScreen s)
            : base(4, 210, p)
        {
            screen = s;
            tp = screen.timepilot;
            direction = dir;
            if (new Random().NextDouble() > 0.5)
                ccw = true;
            for (int i = 0; i < 12; i++)
            {
                spritesCoord[i] = new Rectangle(i * 38, 11 * 38, 38, 38);
            }
        }

        public override void step()
        {
            if (ccw) turnCounterClockWise(2);
            else turnClockWise(2);
            base.step();

            position.X += (int)(Math.Cos(rad(tp.oppositeDirection())) * speed);
            position.Y += (int)(Math.Sin(rad(tp.oppositeDirection())) * speed);
            int res = 10;
            if ((res = this.isHitBy(tp.bullets)) <= 1) screen.projectileIsHit(this, res);
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
            theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[((direction / 30) + 3) % 12], Color.White);
        }


    }
}
