﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
namespace Time_Pilot.FlyingObjects
{
    class Parachute : FlyingObject
    {
        int timeCounter = 0;
        TimePilotScreen screen;
        Rectangle[] spritesCoord = new Rectangle[3];

        public Parachute(TimePilotScreen s)
            : base(0, 90, new Point((int)((new Random().NextDouble() * 1000) % 527), 0))
        {
            screen = s;
            for (int i = 0; i < 3; i++)
            {
                spritesCoord[i] = new Rectangle(38 + i * 38, 267, 38, 38);
            }

        }


        public override void step()
        {

            if (timeCounter == 10)
            {
                if (direction == 90)
                {
                    if (new Random().NextDouble() > 0.5) turnCounterClockWise(10);
                    else turnClockWise(10);
                }
                else if (direction > 90) turnClockWise(10);
                else if (direction < 90) turnCounterClockWise(10);
                timeCounter = 0;
            }
            else timeCounter++;

            base.step();

            position.X += (int)(Math.Cos(rad(screen.timepilot.oppositeDirection())) * 4 + speed);
            position.Y += (int)(Math.Sin(rad(screen.timepilot.oppositeDirection())) * 4 + speed);
        }

        public override int isHitBy(ArrayList bullets)
        {
            if ((Math.Abs((position.X - 19) - 244) < 10) && (Math.Abs((position.Y - 19) - 195) < 10))
            {
                return 1;
            }
            else return 2;
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
            if (getSpeed() == 0)
            {
                if (direction == 90) theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[0], Color.White);
                else if (direction > 90) theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[1], Color.White);
                else if (direction < 90) theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[2], Color.White);
            }


        }
    }


}
