﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;


namespace Time_Pilot.FlyingObjects
{
    class TimePilot : FlyingObject
    {
        public ArrayList bullets = new ArrayList();

        Rectangle[] spritesCoord = new Rectangle[12];

        int maxBullets = 40;
        int hotFire = 0;
        int rafCount = 0;        

        TimePilotScreen screen;

        public TimePilot(TimePilotScreen s)
            : base(0, 0, new Point(263, 214))
        {

            for (int i = 0; i < 12; i++)
            {
                spritesCoord[i] = new Rectangle(i * 38, 0, 38, 38);
            }
            screen = s;
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {            
            if (!endCourse)
            {
                theSpriteBatch.Draw(texture, new Rectangle(posX() - 38, posY() - 38, 38, 38), spritesCoord[((direction / 30) + 3) % 12], Color.White);
                foreach (FlyingObject bullet in bullets)
                {
                    theSpriteBatch.Draw(texture, new Rectangle(bullet.posX(), bullet.posY(), 4, 4), new Rectangle(140, 250, 4, 4), Color.White);
                }
            }
        }
        public void DrawJump(SpriteBatch theSpriteBatch, Texture2D texture, int jumpSize)
        {
            theSpriteBatch.Draw(texture, new Rectangle(posX() - jumpSize, posY() - jumpSize, jumpSize, jumpSize), spritesCoord[2], Color.White);
               
        }     
 


        public int oppositeDirection()
        {
            return (direction + 180) % 360;
        }



        public override void fire()
        {
            if (hotFire == 0)
            {
                rafCount = 3;
                hotFire = 8;

                TPBullet bullet = new TPBullet(this);
                TPBullet bullet1 = new TPBullet(this, 50);
                TPBullet bullet2 = new TPBullet(this, 90);

                if (bullets.Count < maxBullets - 3)
                {
                    bullets.Add(bullet);
                    bullets.Add(bullet1);
                    bullets.Add(bullet2);
                }
                else if (bullets.Count > 0)
                {

                    for (int j = 0; j < bullets.Count / 2; j++) bullets.RemoveAt(j);
                    bullets.Add(bullet);
                    bullets.Add(bullet1);
                    bullets.Add(bullet2);
                }

            }
        }

        public void isHit()
        {
            screen.tpIsHit();
        }




        public override void step()
        {
            if (!endCourse)
            {
                if (hotFire > 0) hotFire--;
                if (rafCount > 0) rafCount--;

                foreach (FlyingObject bullet in bullets)
                {
                    bullet.step();
                }
            }
        }



        public override void turnCounterClockWise()
        {
            if (!endCourse)
            {
                base.turnCounterClockWise();

                if (rafCount > 0)
                {
                    int cpt = 0;
                    foreach (FlyingObject bullet in bullets)
                    {
                        if (cpt >= bullets.Count - 3)
                        {
                            bullet.turnCounterClockWise(10);
                        }
                        cpt++;
                    }
                }
            }
        }



        public override void turnClockWise()
        {
            if (!endCourse)
            {
                base.turnClockWise();

                if (rafCount > 0)
                {
                    int cpt = 0;
                    foreach (FlyingObject bullet in bullets)
                    {
                        if (cpt >= bullets.Count - 3)
                        {
                            bullet.turnCounterClockWise(10);
                        }
                        cpt++;
                    }
                }
            }
        }

    }
}
