﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using XNAExtras;

namespace Time_Pilot.FlyingObjects
{
    class TimedString:FlyingObject
    {
        int cpt = 35;
        int timer = 12;

        String me;
        BitmapFont bmFont;
        Boolean blink;
        Color color;

        public TimedString(String s, Point p, BitmapFont font, Color c, Boolean b):base(0,90,p)
        {            
            me = s;
            bmFont = font;
            blink = b;
            color = c;
        }

        public String getString()
        {
            return me;
        }

        public int timeToLive()
        {
            return cpt;
        }

        public override void step()
        {
            cpt--;            
        }

        public override void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
           
           
            int nWidth = bmFont.MeasureString(me);
            if (!blink)
            {
                bmFont.DrawString(position.X, position.Y, color, me, nWidth);
            }
            else
            {
                if (timer >= 4)
                {
                    bmFont.DrawString(position.X, position.Y, color, me, nWidth);                    
                    timer--;
                }
                else
                {
                    timer--;
                    if (timer == 0) timer = 12;
                }

            }
        }

    }
}
