﻿using System.Collections.Generic;
using System.Text;
using System;
using System.Collections;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using XNAExtras;

namespace Time_Pilot
{
    class Score
    {
        int nbLives = 3;
        int score = 0;
        int toHit = 10;
        int nbLeft = 50;
        int level = 1;
        int nextBonus = 10000;
        BitmapFont bmFont = TimePilotGame.font;
        Rectangle miniTP = new Rectangle(305, 5 * 38, 38, 38);
        Rectangle[] miniLevel = { new Rectangle(343 + 76, 6 * 38, 38, 38),new Rectangle(343, 5 * 38, 38, 38), new Rectangle(343 + 38, 5 * 38, 38, 38),
        new Rectangle(343 + 76, 5 * 38, 38, 38)};
             

        public void addPoints(int p)
        {
            if ((score += p) > nextBonus)
            {
                nbLives++;
                nextBonus += 50000;
                SoundPlayer.Play("sweep5");
            }
        }

        public int getHits()
        {
            return toHit;
        }

        public int getLeft()
        {
            return nbLeft;
        }

        public void setLeft(int i)
        {
            nbLeft = i;
        }

        public void removeOne()
        {
            if (nbLeft > 0) nbLeft--;
        }

        public int getLives()
        {
            return nbLives;
        }

        public void setLives(int n)
        {
            nbLives = n;
        }

        public void removeLive()
        {
            nbLives--;
        }

        public int getLevel()
        {
            return level;
        }

        public void setLevel(int i)
        {
            level = i;
        }

        public int getPoints()
        {
            return score;
        }

        public void Draw(SpriteBatch theSpriteBatch, Texture2D texture)
        {
            String txt = "1-UP: " + getPoints();
            int nWidth = bmFont.MeasureString(txt);
            bmFont.DrawString(10, 15, Color.White, txt, nWidth);

            for (int i = 0; i < getLives(); i++)
                theSpriteBatch.Draw(texture, new Rectangle(200 + (30 * i), -10, 38, 38), miniTP, Color.White);

            txt = "LEVEL: " + getLevel();
            nWidth = bmFont.MeasureString(txt);
            bmFont.DrawString(440, 15, Color.White, txt, nWidth);

            //theSpriteBatch.Draw(texture, new Rectangle(17, 408, 250 - 4 * getLeft(), 30),new Rectangle(305,499,30,30) , Color.Gray);
            int totalImages = getLeft() / 6;
            int leftImage = getLeft() - (totalImages * 6);
            int count = 0;
            for (int i = 0; i < totalImages; i++)
            {
                theSpriteBatch.Draw(texture, new Rectangle(10 + (24 * i), 400, 38, 38), miniLevel[getLevel() % 4], Color.White);
                count++;
            }
            if (leftImage > 0) 
                theSpriteBatch.Draw(texture, new Rectangle(10 + (24 * count), 400, 4*leftImage, 38), miniLevel[getLevel() % 4], Color.White);
            
            
        }
    }



}
