﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;

namespace Time_Pilot
{
    public static class SoundPlayer
    {
        private static AudioEngine engine;
        private static WaveBank wavebank;
        private static SoundBank soundbank;

        public static void Play(string name)
        {
          
            //Cue cue = soundbank.GetCue(name);
            //cue.Play();
            //return cue;      
            soundbank.PlayCue(name);     
                       
        }

        public static void Stop(Cue cue)
        {
            cue.Stop(AudioStopOptions.Immediate);
        }

        /// <summary>
        /// Starts up the sound code
        /// </summary>
        public static void Initialize()
        {
          
            engine = new AudioEngine(@"Content\Sounds\tpbeta2.xgs");
            wavebank = new WaveBank(engine, @"Content\Sounds\Wave Bank.xwb");
            soundbank = new SoundBank(engine, @"Content\Sounds\Sound Bank.xsb");
         
           
             
            
        }


        public static void Update()  //  Added 
        {
            //engine.Update();
        }

        /// <summary>
        /// Shuts down the sound code tidily
        /// </summary>
        public static void Shutdown()
        {
            soundbank.Dispose();
            wavebank.Dispose();
            engine.Dispose();
        }
    }
} 


