﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Audio;
using Microsoft.Xna.Framework.Content;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using Microsoft.Xna.Framework.Storage;
using System.Collections;
using Time_Pilot.Years;
using Time_Pilot.FlyingObjects;

namespace Time_Pilot
{
    class TimePilotScreen
    {
        public Score score;
        public TimePilot timepilot;

        public ArrayList bullets = new ArrayList();
        private ArrayList planes = new ArrayList();
        private ArrayList explosions = new ArrayList();
        public ArrayList timedStrings = new ArrayList();

        private Cloud[] clouds = new Cloud[9];

        private Year currentYear;
        
        int steps = 0;
        int fireCpt = 10;
       
        int cpt = 0;
        Color yearColor;

        private TimePilotGame theGame;
        private float elaspedCounter = 0;

        public int nbFlyingObjects = 0;
        int maxFlyingObjects = 8;

        int startCpt;
        int startCpt1 = 3;
        int lefts = 50;
        Boolean ready = false;
        Boolean ready1 = false;

        Parachute parachute = null;
        int parachuteTimer = 0;

        FinalPlane finalPlane = null;


        public TimePilotScreen(TimePilotGame game)
        {
            score = new Score();
            currentYear = new FirstYear(this);

            timepilot = new TimePilot(this);
            clouds[0] = new Cloud(1, timepilot.oppositeDirection(), new Point(250, 100));
            clouds[1] = new Cloud(2, timepilot.oppositeDirection(), new Point(230, 220));
            clouds[6] = new Cloud(3, timepilot.oppositeDirection(), new Point(0, 0));
            clouds[3] = new Cloud(1, timepilot.oppositeDirection(), new Point(50, 300));
            clouds[4] = new Cloud(2, timepilot.oppositeDirection(), new Point(10, 100));
            clouds[7] = new Cloud(3, timepilot.oppositeDirection(), new Point(300, 300));
            clouds[2] = new Cloud(1, timepilot.oppositeDirection(), new Point(500, 300));
            clouds[5] = new Cloud(2, timepilot.oppositeDirection(), new Point(387, 400));
            clouds[8] = new Cloud(3, timepilot.oppositeDirection(), new Point(500, 470));

            currentYear.drawStartStrings();


            theGame = game;
        }

        public void Draw(SpriteBatch spriteBatch)
        {

            
            
            if (cpt > 0)
            {
                GamePadState currentState = GamePad.GetState(PlayerIndex.One);   
                if (cpt == 100)
                {
                    yearColor = currentYear.color();
                    SoundPlayer.Play("space2");
                             
                    if (currentState.IsConnected)
                        GamePad.SetVibration(PlayerIndex.One, 0.3f, 0.3f);
                }
                if (cpt%3 == 0)
                    currentYear.setColor(Color.White);
                else currentYear.setColor(yearColor);
                timepilot.DrawJump(spriteBatch, theGame.getSprites(),cpt*4);
                if (cpt == 1)
                {                    
                    if (currentState.IsConnected)
                    GamePad.SetVibration(PlayerIndex.One, 0.0f, 0.0f);
                }
                return;
            }            
             
            timepilot.Draw(spriteBatch, theGame.getSprites());
             
            for (int i = 0; i < clouds.Length; i++)
            {
                clouds[i].Draw(spriteBatch, theGame.getSprites());
            }
                       
            foreach (FlyingObject bullet in bullets)
            {
                bullet.Draw(spriteBatch, theGame.getSprites());
            }
            foreach (FlyingObject plane in planes)
            {
                plane.Draw(spriteBatch, theGame.getSprites());
            }
            foreach (FlyingObject explosion in explosions)
            {
                explosion.Draw(spriteBatch, theGame.getSprites());
            }
            foreach (TimedString timedString in timedStrings)
            {
                timedString.Draw(spriteBatch, theGame.getSprites());
            }
            if (finalPlane != null) finalPlane.Draw(spriteBatch, theGame.getSprites());
            if (parachute != null) parachute.Draw(spriteBatch, theGame.getSprites());
            score.Draw(spriteBatch, theGame.getSprites());
        }

        public void update(float elapsed)
        {
            elaspedCounter += elapsed;
            //if (elaspedCounter > 0.025)
            if (true)
            {
                if (cpt > 0)
                {
                    cpt--;
                    return;
                }
                if ((startCpt == 0) && (ready)) restart(true);
                if (ready) startCpt--;
                if (ready1) startCpt1--;

                // go to next time perido
                if ((ready1) && (startCpt1 == 0))
                {                    
                    {                        
                        score.addPoints(1500);                                                                                                                        
                        score.setLevel(score.getLevel() + 1);
                        nextYear();
                        startCpt1 = 3;
                        ready1 = false;
                        cpt = 100;
                    }                    
                }

                // update time pilot
                timepilot.step();
                
                //update parachute
                if ((parachuteTimer > 400) && (parachute == null))
                {
                    parachute = new Parachute(this);
                    parachuteTimer = 0;
                }
                if (parachute != null)
                {
                    parachute.step();
                    if (parachute.posY() > 500) parachute = null;
                }
                else parachuteTimer++;


                // move clouds
                for (int i = 0; i < clouds.Length; i++)
                {
                    clouds[i].step();
                }
                // move bullets
                ArrayList bulletsToRemove = new ArrayList();
                foreach (FlyingObject bullet in bullets)
                {

                    if (bullet.endCourse ||
                        (bullet.posX() < 0) ||
                        (bullet.posX() > 527) ||
                        (bullet.posY() < 0) ||
                        (bullet.posY() > 428)
                        )                       
                        bulletsToRemove.Add(bullet);
                    else bullet.step();
                }
                foreach (FlyingObject bullet in bulletsToRemove)
                {
                    bullets.Remove(bullet);
                }
                // add planes for currentYear
                if ((nbFlyingObjects <= maxFlyingObjects) && (steps == currentYear.steps()))
                {
                    currentYear.addPlane(planes, maxFlyingObjects - nbFlyingObjects);
                    steps = 0;
                }
                else steps++;
                // current planes move, fire, bomb
                Random rand = new Random();
                foreach (FlyingObject plane in planes)
                {
                    plane.step();
                    if (plane.bulletWillHit() && rand.NextDouble() > 0.99)
                    {
                        plane.fire();
                        SoundPlayer.Play("MULTGUN");
                        if (rand.NextDouble() > 0.3)
                        {
                            plane.dropBomb();                                                       
                        }
                    }
                }
                // manage parachute
                if (parachute != null)
                {
                    switch (parachute.isHitBy(null))
                    {
                        case 1:
                            score.addPoints(500);
                            TimedString ts = new TimedString("500", parachute.getPosition(), TimePilotGame.font, Color.White, true);
                            SoundPlayer.Play("zap3");
                            timedStrings.Add(ts);
                            parachute = null;
                            break;
                        default:
                            break;
                    }
                }


                // manage big boss
                if (((score.getLeft() == 0) && (finalPlane == null)) ||
                     ((score.getLevel() == 2) && (finalPlane == null)))
                    finalPlane = currentYear.addFinalPlane();
                if (finalPlane != null)
                {
                    if (finalPlane.bulletWillHit()) finalPlane.fire();
                    finalPlane.step();
                }


                // manage explosions
                ArrayList explosionsToRemove = new ArrayList();
                foreach (FlyingObject explosion in explosions)
                {
                    if (((Explosion)explosion).timeToLive > 0)
                        explosion.step();
                    else
                        explosionsToRemove.Add(explosion);
                }
                foreach (FlyingObject explosion in explosionsToRemove)
                {
                    explosions.Remove(explosion);
                }
                // remove planes that have been hit
                ArrayList planesToRemove = new ArrayList();
                foreach (FlyingObject plane in planes)
                {
                    if (plane.endCourse)
                        planesToRemove.Add(plane);
                }
                foreach (FlyingObject plane in planesToRemove)
                {
                    planes.Remove(plane);
                    nbFlyingObjects--;
                }
                // manage timed screens
                ArrayList stringsToRemove = new ArrayList();
                foreach (TimedString timedString in timedStrings)
                {
                    if (timedString.timeToLive() > 0)
                        timedString.step();
                    else stringsToRemove.Add(timedString);
                }
                foreach (FlyingObject timedString in stringsToRemove)
                {
                    timedStrings.Remove(timedString);
                    nbFlyingObjects--;
                }



                // time frame for display
                elaspedCounter = 0;
            }
        }

        public void right()
        {

            timepilot.turnClockWise();
            for (int i = 0; i < clouds.Length; i++)
                clouds[i].setDirection(timepilot.oppositeDirection());

        }        



        public void left()
        {
            timepilot.turnCounterClockWise();
            for (int i = 0; i < clouds.Length; i++)
                clouds[i].setDirection(timepilot.oppositeDirection());
        }

        public void fire()
        {
            timepilot.fire();
            if (fireCpt == 0)
            {
                SoundPlayer.Play("dp_timepilot_rapidfire");
                fireCpt = 10;
            }
            else fireCpt--;
        }

        public Year getYear()
        {
            return currentYear;
        }

        public void planeIsHit(FlyingObject bp, int res)
        {
            switch (res)
            {
                case 0:
                    explosions.Add(new Explosion(bp.getPosition(), "a"));
                    SoundPlayer.Play("EXPLOS");
                    bp.endCourse = true;
                    bp = null;
                    score.addPoints(50);
                    score.removeOne();
                    break;
                case 1:
                    if (tpIsHit())
                    {
                        explosions.Add(new Explosion(bp.getPosition(), "a"));
                        SoundPlayer.Play("EXPLOS");
                        bp.endCourse = true;
                        bp = null;
                    }
                    break;
                default:
                    break;
            }
        }

        public Boolean tpIsHit()
        {
            if (!timepilot.endCourse)
            {
                explosions.Add(new Explosion(new Point(244, 215), "tp"));
                GamePadState currentState = GamePad.GetState(PlayerIndex.One);   
                if (currentState.IsConnected)
                    GamePad.SetVibration(PlayerIndex.One, 1.0f, 1.0f);
                SoundPlayer.Play("XPLODE2");
                timepilot.bullets = new ArrayList();
                score.removeLive();

                timepilot.endCourse = true;

                ready = true;
                startCpt = 50;
                if (score.getLives() == 0)
                {
                    timedStrings.Add(new TimedString("GAME OVER", new Point(210, 160), TimePilotGame.font, Color.Yellow, true));
                    timedStrings.Add(new TimedString("YOU SCORED " + score.getPoints(), new Point(180, 200), TimePilotGame.font, Color.Red, false));                    
                }               
                return true;
            }
            else return false;
        }

        public void projectileIsHit(FlyingObject bomb, int res)
        {
            switch (res)
            {
                case 0:
                    explosions.Add(new Explosion(bomb.getPosition(), "a"));
                    SoundPlayer.Play("EXPLOSIN");
                    bomb.endCourse = true;
                    bomb = null;
                    score.addPoints(10);
                    break;
                case 1:
                    if (tpIsHit())
                    {
                        explosions.Add(new Explosion(bomb.getPosition(), "a"));
                        SoundPlayer.Play("EXPLOSIN");
                        bomb.endCourse = true;
                        bomb = null;
                        score.removeLive();
                    }
                    break;
                default:
                    break;
            }
        }

        public void finalPlaneIsHit(FlyingObject bp, int res, int nbHits)
        {
            Random rand = new Random();
            int sign = 1;
            if (rand.NextDouble() > 0.5) sign = -1;
            int diffX = (int)(rand.NextDouble() * 25) * sign;
            int diffY = (int)(rand.NextDouble() * 25) * sign;
            switch (res)
            {
                case 0:
                    explosions.Add(new Explosion(
                    new Point(bp.posX() + 19 + diffX, bp.posY() + 19 + diffY), "a"));
                    if (nbHits == 45)
                    {
                        if (finalPlane != null)
                        {
                            if (finalPlane.notDone)
                            {
                                score.addPoints(1000);
                                finalPlane.notDone = false;
                                if (score.getLeft() > 0)
                                {
                                    TimedString ts = new TimedString("1000", finalPlane.getPosition(), TimePilotGame.font, Color.White, true);
                                    timedStrings.Add(ts);
                                }
                            }
                        }
                        explosions.Add(new Explosion(
                        new Point(bp.posX() + 19, bp.posY() + 19), "l"));
                        //SoundPlayer.Play("XPLODE1");
                        finalPlane = null;
                        if (score.getLeft() <= 0)
                        {
                            foreach (FlyingObject bullet in bullets)
                                bullet.endCourse = true;
                            foreach (FlyingObject flyer in planes)
                            {
                                explosions.Add(new Explosion(flyer.getPosition(), "a"));                                
                                flyer.endCourse = true;
                                nbFlyingObjects--;
                            }

                            ready1 = true;
                        }
                    }
                    break;
                case 1:
                    if (tpIsHit())
                    {
                        explosions.Add(new Explosion(
                        new Point(bp.posX() + 19 + diffX, bp.posY() + 19 + diffY), "a"));
                        SoundPlayer.Play("EXPLOS");
                    }
                    break;
                default:
                    break;
            }
        }


        public void restart(Boolean s)
        {
            if (score.getLives() > 0)
            {

                timedStrings = new ArrayList();
                planes = new ArrayList();
                explosions = new ArrayList();
                bullets = new ArrayList();

                parachuteTimer = 0;
                nbFlyingObjects = 0;
                steps = 0;
                finalPlane = null;
                parachute = null;

                timepilot.endCourse = false;
                timepilot.bullets = new ArrayList();
                timepilot.setDirection(0);

                clouds[0] = new Cloud(1, timepilot.oppositeDirection(), new Point(250, 100));
                clouds[1] = new Cloud(2, timepilot.oppositeDirection(), new Point(230, 220));
                clouds[6] = new Cloud(3, timepilot.oppositeDirection(), new Point(0, 0));
                clouds[3] = new Cloud(1, timepilot.oppositeDirection(), new Point(50, 300));
                clouds[4] = new Cloud(2, timepilot.oppositeDirection(), new Point(10, 100));
                clouds[7] = new Cloud(3, timepilot.oppositeDirection(), new Point(300, 300));
                clouds[2] = new Cloud(1, timepilot.oppositeDirection(), new Point(500, 300));
                clouds[5] = new Cloud(2, timepilot.oppositeDirection(), new Point(387, 400));
                clouds[8] = new Cloud(3, timepilot.oppositeDirection(), new Point(500, 470));

                if (s)
                {
                    timedStrings.Add(new TimedString("PLAYER 1", new Point(220, 160), TimePilotGame.font, Color.White, false));
                    timedStrings.Add(new TimedString("READY", new Point(230, 230), TimePilotGame.font, Color.White, false));
                    GamePadState currentState = GamePad.GetState(PlayerIndex.One);
                    if (currentState.IsConnected)
                        GamePad.SetVibration(PlayerIndex.One, 0.0f, 0.0f);
                }
                ready = false;
            }
            else
            {
                theGame.stopThatGame();
            }
        }

        public void nextYear()
        {
            switch (score.getLevel() % 4)
            {
                case 1: currentYear = new FirstYear(this);
                    lefts += 10;
                    break;
                case 2: currentYear = new SecondYear(this);
                    break;
                case 3: currentYear = new ThirdYear(this);
                    break;
                case 0: currentYear = new FourthYear(this);
                    break;
                default:
                    break;
            }
                         
            score.setLeft(lefts);
            restart(false);            
            currentYear.drawStartStrings();
        }



    }
}
