﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System.Collections;
using Time_Pilot.FlyingObjects;

namespace Time_Pilot.Years
{
    class FourthYear:Year
    {
        TimePilotScreen screen;
        Color col = new Color(124, 109, 146);

        public FourthYear(TimePilotScreen s)
        {
            screen = s;
        }

        public override Color color()
        {
            return col;
        }

        public override void setColor(Color c)
        {
            col = c;
        }

        public override int steps()
        {
            return 10;
        }

        public override void drawStartStrings()
        {            
            screen.timedStrings.Add(new TimedString("1982 A.D", new Point(220, 230), TimePilotGame.font, Color.Yellow, true));
            screen.timedStrings.Add(new TimedString("PLAYER 1", new Point(220, 160), TimePilotGame.font, Color.White, false));
            screen.timedStrings.Add(new TimedString("STAGE " + screen.score.getLevel(), new Point(220, 260), TimePilotGame.font, Color.White, false));           
        }


        public override void addPlane(ArrayList b, int nbLeft)
        {

   int[] down = {30,60,90,120,150};
   int[] up = {210,240,270,300,330};
   int[] left = {120,150,180,210,240};
   int[] right = {60,30,0,330,300};
   Point[] left3 = {new Point(0,0),new Point(20,-20),new Point(20,20)};
   Point[] right3 = {new Point(0,0),new Point(-20,-20),new Point(-20,20)};
   Point[] up3 = {new Point(0,0),new Point(-20,20),new Point(20,20)};
   Point[] down3 = {new Point(0,0),new Point(-20,-20),new Point(20,-20)};
   Point[] right5 = {new Point(0,0),new Point(20,-20),new Point(20,20),new Point(30,-30),new Point(30,30)};
   Point[] left5 = {new Point(0,0),new Point(-20,20),new Point(20,20),new Point(-30,30),new Point(-30,30)};
   Point[] up5 = {new Point(0,0),new Point(-20,20),new Point(20,20),new Point(-30,30),new Point(-30,30)};
   Point[] down5 = {new Point(0,0),new Point(-20,-20),new Point(20,-20),new Point(-30,-30),new Point(30,-30)};
   Mirage bp;
   int x = 0;
   int y = 0;
   int dir = 0;
   double rand;



     rand = new Random().NextDouble();

     if (rand <= 0.25) {
       x = -30;
       dir = right[(int)((new Random().NextDouble() * 10) % 5)];
     }
     else if ((rand > 0.25) && (rand <= 0.5)) {
       x = 557;
       dir = left[(int)((new Random().NextDouble() * 10) % 5)];
     }
     else if ((rand > 0.5) && (rand <= 0.75)) {
       y = -30;
       dir = down[(int)((new Random().NextDouble() * 10) % 5)];
     }
     else if ((rand > 0.75) && (rand <= 1)) {
       y = 458;
       dir = up[(int)((new Random().NextDouble() * 10) % 5)];
     }

     if (x == 0) x = (int)((1000 * new Random().NextDouble()) % 527);
     else y = (int)((1000 * new Random().NextDouble()) % 428);

       if (nbLeft >= 5) {
           SoundPlayer.Play("f-16");
        if (x == -30) {
          for (int i = 0; i < 5; i++) {
            bp = new Mirage(dir,new Point(x-right5[i].X,y-right5[i].Y),screen);
            b.Add(bp);
            
          }
          screen.nbFlyingObjects+=5;
        } else if (x == 557) {
          for (int i = 0; i < 5; i++) {
              bp = new Mirage(dir, new Point(x - left5[i].X, y - left5[i].Y), screen);
            b.Add(bp);
           
          }
          screen.nbFlyingObjects += 5;
        } else if (y == -30) {
          for (int i = 0; i < 5; i++) {
              bp = new Mirage(dir, new Point(x - down5[i].X, y - down5[i].Y),screen);
            b.Add(bp);
           
          }
          screen.nbFlyingObjects += 5;
         } else if (y == 458) {
          for (int i = 0; i < 5; i++) {
              bp = new Mirage(dir, new Point(x - up5[i].X, y - up5[i].Y), screen);
            b.Add(bp);
            
          }
          screen.nbFlyingObjects += 5;
         }
       }
    
       else if (nbLeft >= 3) {
         if (x == -30) {
          for (int i = 0; i < 3; i++) {
              bp = new Mirage(dir, new Point(x - right3[i].X, y - right3[i].Y), screen);
            b.Add(bp);
           
          }
          screen.nbFlyingObjects += 3;
         }
         else if (x == 557) {
          for (int i = 0; i < 3; i++) {
              bp = new Mirage(dir, new Point(x - left3[i].X, y - left3[i].Y), screen);
            b.Add(bp);
           
          }
          screen.nbFlyingObjects += 3;
         }
         else if (y == -30) {
          for (int i = 0; i < 3; i++) {
              bp = new Mirage(dir, new Point(x - down3[i].X, y - down3[i].Y), screen);
            b.Add(bp);
            
          }
          screen.nbFlyingObjects += 3;
         }
         else if (y == 458) {
          for (int i = 0; i < 3; i++) {
              bp = new Mirage(dir, new Point(x - up3[i].X, y - up3[i].Y), screen);
            b.Add(bp);
           
          }
          screen.nbFlyingObjects += 3;
         }
       }
     else if (nbLeft >= 1) {
         bp = new Mirage(dir, new Point(x, y), screen);
       b.Add(bp);
      
       screen.nbFlyingObjects++;
     }
  }

        public override FinalPlane addFinalPlane()
        {

            if (new Random().NextDouble() > 0.5)
                return new Hawacs(0, new Point(-60, (int)((new Random().NextDouble() * 1000) % 526)), screen);
            else return new Hawacs(180, new Point(560, (int)((new Random().NextDouble() * 1000) % 526)), screen);

        }

    }
}
