﻿using System;
using System.Collections.Generic;
using System.Text;
using Microsoft.Xna.Framework;
using Microsoft.Xna.Framework.Graphics;
using Microsoft.Xna.Framework.Input;
using System.Collections;
using Time_Pilot.FlyingObjects;

namespace Time_Pilot.Years
{
    class ThirdYear : Year
    {

        TimePilotScreen screen;
        Color col = new Color(154, 101, 152);

        public ThirdYear(TimePilotScreen s)
        {
            screen = s;
        }

        public override Color color()
        {
            return col;
        }

        public override void setColor(Color c)
        {
            col = c;
        }

        public override int steps()
        {
            return 17;
        }

        public override void drawStartStrings()
        {           
            screen.timedStrings.Add(new TimedString("1970 A.D", new Point(220, 230), TimePilotGame.font, Color.Yellow, true));
            screen.timedStrings.Add(new TimedString("PLAYER 1", new Point(220, 160), TimePilotGame.font, Color.White, false));
            screen.timedStrings.Add(new TimedString("STAGE " + screen.score.getLevel(), new Point(220, 260), TimePilotGame.font, Color.White, false));           
        }



        public override void addPlane(ArrayList b, int nbLeft)
        {

            int[] down = { 30, 60, 90, 120, 150 };
            int[] up = { 210, 240, 270, 300, 330 };
            int[] left = { 120, 150, 180, 210, 240 };
            int[] right = { 60, 30, 0, 330, 300 };
            Point[] left3 = { new Point(0, 0), new Point(20, -20), new Point(20, 20) };
            Point[] right3 = { new Point(0, 0), new Point(-20, -20), new Point(-20, 20) };
            Point[] up3 = { new Point(0, 0), new Point(-20, 20), new Point(20, 20) };
            Point[] down3 = { new Point(0, 0), new Point(-20, -20), new Point(20, -20) };
            Helicopter bp;
            int x = 0;
            int y = 0;
            int dir = 0;
            double rand;



            rand = new Random().NextDouble();

            if (rand <= 0.25)
            {
                x = -30;
                dir = right[(int)((new Random().NextDouble() * 10) % 5)];
            }
            else if ((rand > 0.25) && (rand <= 0.5))
            {
                x = 557;
                dir = left[(int)((new Random().NextDouble() * 10) % 5)];
            }
            else if ((rand > 0.5) && (rand <= 0.75))
            {
                y = -30;
                dir = down[(int)((new Random().NextDouble() * 10) % 5)];
            }
            else if ((rand > 0.75) && (rand <= 1))
            {
                y = 458;
                dir = up[(int)((new Random().NextDouble() * 10) % 5)];
            }

            if (x == 0) x = (int)((1000 * new Random().NextDouble()) % 527);
            else y = (int)((1000 * new Random().NextDouble()) % 428);

            if ((nbLeft >= 3) && (new Random().NextDouble() > 0.5))
            {
                SoundPlayer.Play("bo-ch47");
                if (x == -30)
                {
                    for (int i = 0; i < 3; i++)
                    {
                        bp = new Helicopter(dir, new Point(x - right3[i].X, y - right3[i].Y),screen);
                        b.Add(bp);                        
                    }
                    screen.nbFlyingObjects += 3;
                }
                else if (x == 557)
                {
                    for (int i = 0; i < 3; i++)
                    {
                        bp = new Helicopter(dir, new Point(x - left3[i].Y, y - left3[i].Y), screen);
                        b.Add(bp);                        
                    }
                    screen.nbFlyingObjects += 3;
                }
                else if (y == -30)
                {
                    for (int i = 0; i < 3; i++)
                    {
                        bp = new Helicopter(dir, new Point(x - down3[i].X, y - down3[i].Y), screen);
                        b.Add(bp);                       
                    }
                    screen.nbFlyingObjects += 3;
                }
                else if (y == 458)
                {
                    for (int i = 0; i < 3; i++)
                    {
                        bp = new Helicopter(dir, new Point(x - up3[i].X, y - up3[i].Y), screen);
                        b.Add(bp);                        
                    }
                    screen.nbFlyingObjects += 3;
                }
            }
            else if (nbLeft >= 1)
            {
                bp = new Helicopter(dir, new Point(x, y), screen);
                b.Add(bp);                
                screen.nbFlyingObjects++;
            }
        }

        public override FinalPlane addFinalPlane()
        {
            if (new Random().NextDouble() > 0.5)
                return new Banana(0, new Point(-60, (int)((new Random().NextDouble() * 1000) % 526)), screen);
            else return new Banana(180, new Point(560, (int)((new Random().NextDouble() * 1000) % 526)), screen);
        }




    }
}
